"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var cors = require("cors");
var express = require("express");
var proxy = require("express-http-proxy");
var body_parser_1 = require("body-parser");
var server;
var backendMockPlugin = {
    setup: function () {
        if (!this.config) {
            throw new Error("Missing config");
        }
        var _a = this.config.fake, _b = _a[0], fakePort = _b === void 0 ? 8081 : _b, _c = _a[1], fakeHost = _c === void 0 ? "localhost" : _c;
        var _d = this.config.backend, _e = _d[0], backendPort = _e === void 0 ? 8080 : _e, _f = _d[1], backendHost = _f === void 0 ? "localhost" : _f;
        var app = express();
        app.use(cors()); // different port
        app.use(body_parser_1.urlencoded({ extended: false })); // form data
        app.use(body_parser_1.json()); // body
        app.use("/", proxy("http://" + fakeHost + ":" + fakePort));
        server = app.listen(backendPort, backendHost);
    },
    teardown: function () {
        server.close();
    },
};
module.exports = backendMockPlugin;
